-- このファイルはUTF-8で記載すること
/*****************************
 * D_USER
 *****************************/
CREATE TABLE [D_USER](
	[ID] TEXT NOT NULL
	,[MAIL] TEXT NOT NULL UNIQUE
	,[PWD] TEXT NOT NULL
	,[HANDLE] TEXT NOT NULL
	,[HANDLE_KANA] TEXT
	,[REG_DATE] REAL NOT NULL
	,[DEL_DATE] REAL --削除したら4ヶ月は再登録できない
	,[STATUS] INTEGER NOT NULL
	,[LAST_LOGIN] REAL
	,[LAST_LOGOUT] REAL
	,[FAIL_LOGIN_LIMIT] INTEGER NOT NULL --連続ログイン失敗上限初期値
	,[LOCK_TERM] INTEGER NOT NULL --連続ログイン失敗時ロック時間(分)初期値
	,[LOCK_DATE] REAL
	,[USE_MAIL] INTEGER NOT NULL --メールを受信する
	,[FREEZE] INTEGER NOT NULL --0:凍結されていない、1:凍結されている
	,[NOTE] TEXT
	,PRIMARY KEY(ID)
);
/*****************************
 * D_SITE
 *****************************/
CREATE TABLE [D_SITE](
	[ID] INTEGER NOT NULL
	,[URL] TEXT NOT NULL UNIQUE
	,[NAME] TEXT NOT NULL
	,[NAME_KANA] TEXT
	,[USER_ID] TEXT NOT NULL
	,[HANDLE] TEXT NOT NULL
	,[HANDLE_KANA] TEXT
	,[SERVER_TYPE] INTEGER NOT NULL
	,[SERVER_RULE_URL] TEXT
	,[BANNER_URL] TEXT
	,[DESC] TEXT NOT NULL
	,[MEDIA] INTEGER NOT NULL
	,[DENY_OTHER_MEDIA] INTEGER NOT NULL
	,[SITE_TYPE] INTEGER NOT NULL
	,[REG_DATE] REAL NOT NULL
	,[UPD_DATE] REAL --このレコード自体の更新日時
	,[DEL_DATE] REAL --削除したら4ヶ月は再登録できない
	,[SORTABLE_DATE] REAL --表示用ソート日時。24時間以内は更新されない
	,[STEALTH] INTEGER NOT NULL --0:規定値、1:ステルスモード
	,[MANAGE_STATUS] INTEGER NOT NULL
	,[BROWSE_STATUS] INTEGER NOT NULL
	,[LOWER_AGE] INTEGER NOT NULL
	,[RESTRICTION] INTEGER NOT NULL
	,[MOVED] REAL --URL変更時点の日時
	,[DEADLINE] REAL
	,[STATUS] INTEGER NOT NULL
	,[SHOW] INTEGER NOT NULL --0:サーチに表示しない(＝一時削除)、1:表示する
	,[FREEZE] INTEGER NOT NULL --0:凍結されていない、1:凍結されている
	,[NOTE] TEXT
	,PRIMARY KEY(ID AUTOINCREMENT)
);
/*****************************
 * D_COUNTRY
 *****************************/
CREATE TABLE [D_COUNTRY](
	[SITE_ID] INTEGER NOT NULL
	,[COUNTRY_ID] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,COUNTRY_ID)
);
/*****************************
 * D_CHARA
 *****************************/
CREATE TABLE [D_CHARA](
	[SITE_ID] INTEGER NOT NULL
	,[CHARA_ID] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,CHARA_ID)
);
/*****************************
 * D_CATE
 *****************************/
CREATE TABLE [D_CATE](
	[SITE_ID] INTEGER NOT NULL
	,[CATE_ID1] INTEGER NOT NULL
	,[CATE_ID2] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,CATE_ID1,CATE_ID2)
);
/*****************************
 * D_SCALE
 *****************************/
CREATE TABLE [D_SCALE](
	[SITE_ID] INTEGER NOT NULL
	,[SCALE_ID] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,SCALE_ID)
);
/*****************************
 * D_MOOD
 *****************************/
CREATE TABLE [D_MOOD](
	[SITE_ID] INTEGER NOT NULL
	,[MOOD_ID] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,MOOD_ID)
);
/*****************************
 * D_CAUTION
 *****************************/
CREATE TABLE [D_CAUTION](
	[SITE_ID] INTEGER NOT NULL
	,[CAUTION_ID] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,CAUTION_ID)
);
/*****************************
 * D_CP
 *****************************/
CREATE TABLE [D_CP](
	[SITE_ID] INTEGER NOT NULL
	,[CHARA_ID1] INTEGER NOT NULL
	,[CHARA_ID2] INTEGER NOT NULL
	,[REVERSE] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,CHARA_ID1,CHARA_ID2)
);
/*****************************
 * D_CP_TYPE
 *****************************/
CREATE TABLE [D_CP_TYPE](
	[SITE_ID] INTEGER NOT NULL
	,[SEX1] INTEGER NOT NULL
	,[SEX2] INTEGER NOT NULL
	,[PRIORITY] INTEGER
	,PRIMARY KEY(SITE_ID,SEX1,SEX2)
);
/*****************************
 * D_HIST
 *****************************/
CREATE TABLE [D_HIST](
	[SITE_ID] INTEGER NOT NULL
	,[UPD_DATE] REAL NOT NULL
	,[TEXT] TEXT NOT NULL
	,PRIMARY KEY(SITE_ID,UPD_DATE)
);
