-- このファイルはUTF-8で記載すること
/*****************************
 * V_SUM_MEDIA
 *****************************/
CREATE VIEW V_SUM_MEDIA AS
	SELECT S.MEDIA AS ID, M.NAME AS NAME, COUNT(S.ID) AS TOTAL
	FROM D_SITE S INNER JOIN M_MEDIA M
	ON S.MEDIA = M.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY S.MEDIA;
/*****************************
 * V_SUM_SITE_TYPE
 *****************************/
CREATE VIEW V_SUM_SITE_TYPE AS
	SELECT S.SITE_TYPE AS ID, M.NAME AS NAME, COUNT(S.ID) AS TOTAL
	FROM D_SITE S INNER JOIN M_SITE_TYPE M
	ON S.SITE_TYPE = M.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY S.SITE_TYPE;
/****************************
 * V_SUM_CATE
 *****************************/
CREATE VIEW V_SUM_CATE AS
	SELECT D.CATE_ID1 || ',' || D.CATE_ID2 AS ID, M.NAME AS NAME, M.DESC AS DESC, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_CATE D INNER JOIN M_CATE M, D_SITE S
	ON D.CATE_ID1 = M.ID1 AND D.CATE_ID2 = M.ID2 AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CATE_ID1, D.CATE_ID2;
/*****************************
 * V_SUM_SCALE
 *****************************/
CREATE VIEW V_SUM_SCALE AS
	SELECT D.SCALE_ID AS ID, M.NAME AS NAME, M.DESC AS DESC, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_SCALE D INNER JOIN M_SCALE M, D_SITE S
	ON D.SCALE_ID = M.ID AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.SCALE_ID;
/*****************************
 * V_SUM_MOOD
 *****************************/
CREATE VIEW V_SUM_MOOD AS
	SELECT D.MOOD_ID AS ID, M.NAME AS NAME, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_MOOD D INNER JOIN M_MOOD M, D_SITE S
	ON D.MOOD_ID = M.ID AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.MOOD_ID;
/*****************************
 * V_SUM_CAUTION
 *****************************/
CREATE VIEW V_SUM_CAUTION AS
	SELECT D.CAUTION_ID AS ID, M.NAME AS NAME, M.DESC AS DESC, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_CAUTION D INNER JOIN M_CAUTION M, D_SITE S
	ON D.CAUTION_ID = M.ID AND D.SITE_ID = S.ID
	WHERE M.KIND = 1 AND S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CAUTION_ID;
/*****************************
 * V_SUM_RESTRICTION
 *****************************/
CREATE VIEW V_SUM_RESTRICTION AS
	SELECT S.RESTRICTION AS ID, M.MENU_NAME AS NAME, COUNT(S.ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_SITE S INNER JOIN M_RESTRICTION M
	ON S.RESTRICTION = M.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY S.RESTRICTION;
/*****************************
 * V_SUM_COUNTRY
 *****************************/
CREATE VIEW V_SUM_COUNTRY AS
	SELECT D.COUNTRY_ID AS ID, M.NAME AS NAME, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_COUNTRY D INNER JOIN M_COUNTRY M, D_SITE S
	ON D.COUNTRY_ID = M.ID AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.COUNTRY_ID;
/*****************************
 * V_SUM_CHARA
 *****************************/
CREATE VIEW V_SUM_CHARA AS
	SELECT D.CHARA_ID AS ID, M.NAME AS NAME, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_CHARA D INNER JOIN M_CHARA M, D_SITE S
	ON D.CHARA_ID = M.ID AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CHARA_ID;
/*****************************
 * V_SUM_CP_TYPE
 *****************************/
CREATE VIEW V_SUM_CP_TYPE AS
	SELECT D.SEX1 || ',' || D.SEX2 AS ID, D.SEX1 AS SEX1, D.SEX2 AS SEX2, M.NAME AS NAME, M.DESC AS DESC, COUNT(D.SITE_ID) AS TOTAL, M.SORT_KEY AS SORT_KEY
	FROM D_CP_TYPE D INNER JOIN M_CP_TYPE M, D_SITE S
	ON D.SEX1 = M.ID1 AND D.SEX2 = M.ID2 AND D.SITE_ID = S.ID
	WHERE S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.SEX1, D.SEX2;
/*****************************
 * V_SUM_CP_MF
 *****************************/
CREATE VIEW V_SUM_CP_MF AS
	SELECT D.CHARA_ID1 || ',' || D.CHARA_ID2 AS ID, M1.NAME || 'x' || M2.NAME AS NAME, COUNT(D.ROWID) AS TOTAL
	FROM D_CP D INNER JOIN M_CHARA M1, M_CHARA M2, D_SITE S
	ON D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND D.SITE_ID = S.ID
	WHERE M1.SEX != M2.SEX AND S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CHARA_ID1, D.CHARA_ID2;
/*****************************
 * V_SUM_CP_MM
 *****************************/
CREATE VIEW V_SUM_CP_MM AS
	SELECT D.CHARA_ID1 || ',' || D.CHARA_ID2 AS ID, M1.NAME || 'x' || M2.NAME AS NAME, COUNT(D.ROWID) AS TOTAL
	FROM D_CP D INNER JOIN M_CHARA M1, M_CHARA M2, D_SITE S
	ON D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND D.SITE_ID = S.ID
	WHERE M1.SEX = 0 AND M2.SEX = 0 AND S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CHARA_ID1, D.CHARA_ID2;
/*****************************
 * V_SUM_CP_FF
 *****************************/
CREATE VIEW V_SUM_CP_FF AS
	SELECT D.CHARA_ID1 || ',' || D.CHARA_ID2 AS ID, M1.NAME || 'x' || M2.NAME AS NAME, COUNT(D.ROWID) AS TOTAL
	FROM D_CP D INNER JOIN M_CHARA M1, M_CHARA M2, D_SITE S
	ON D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND D.SITE_ID = S.ID
	WHERE M1.SEX = 1 AND M2.SEX = 1 AND S.DEL_DATE IS NULL AND S.SHOW = 1 AND S.STATUS != 9
	AND (S.DEADLINE IS NULL OR S.DEADLINE > DATETIME('now'))
	GROUP BY D.CHARA_ID1, D.CHARA_ID2;
