<?php
require_once(dirname(__FILE__) . '/common.php');
/***********************************************************
 * error_log関数を利用した簡易ログクラス。
 * ---------------------------------------------------------
 * @param string $path パスつきファイル名
 * @return データベースハンドル
 ***********************************************************/
class EazyLog {
	//TODO 前日以前のログファイルを圧縮。一ヶ月以上前のログは削除。
	//それともcronでやる？ あるいは外部プログラムを実行する？
	private function writeLog($type, $var) {
		$msg = null;
		if (is_scalar($var)) {
			$msg = $var;
		} else if (is_array($var)) {
			$msg = '';
			foreach($var as $key=>$val) {
				$msg .= '['.$key.']'.$val.' ';
			}
		} else if (is_object($var)) {
			$msg = $var;
		} else if (is_resource($var)) {
			$msg = $var;
		}
		$filename = date('Y-m-d').'.log';
		$now = date('Y-m-d H:i:s ');
		error_log($now.$type.' '.$msg."\n", 3, LOG_PATH.$filename);
	}
	public function writeInfo($var) {
		$this->writeLog('INFO', $var);
	}
	public function writeWarn($var) {
		$this->writeLog('WARN', $var);
	}
	public function writeError($var) {
		$this->writeLog('ERROR', $var);
	}
	public function writeDebug($var) {
		$this->writeLog('DEBUG', $var);
	}
}
