<?php
define('SESSION_PATH', dirname(__FILE__) . '/../../ssn');
define('SESSION_EXPIRE', 60*3); //3時間
define('SESSION_COOKIE_LIFETIME', 3*60*60); //3時間（3*60分*60秒)
define('SESSION_COOKIE_PATH', '/d/');
define('SESSION_COOKIE_NAME', '12Search');
//セッション関連
function session_setCookieParams() {
	session_set_cookie_params(SESSION_COOKIE_LIFETIME, SESSION_COOKIE_PATH);
}
function session_setPath() {
	session_save_path(SESSION_PATH);
}
function session_initializeDefine() {
	session_name(SESSION_COOKIE_NAME);
	session_cache_limiter('private_no_expire');
	session_cache_expire(SESSION_EXPIRE);
}
function session_getSession() {
	session_name(SESSION_COOKIE_NAME);
	session_set_cookie_params(SESSION_COOKIE_LIFETIME, SESSION_COOKIE_PATH);
	session_save_path(SESSION_PATH);
	session_cache_limiter('private_no_expire');
	session_cache_expire(SESSION_EXPIRE);
	//TODO Cookie削除ヘッダ送信
	$id = session_id();
	if (!strlen($id)) return false;
	session_start();
	if (!isset($_SESSION['ip']) ||
		!isset($_SESSION['ua']) ||
		($_SESSION['ip'] != $_SERVER['REMOTE_ADDR']) &&
		($_SESSION['ua'] != $_SERVER['HTTP_USER_AGENT'])) {
		session_removeSession();
		return false;
	}
	$result = session_regenerate_id(true);
	if (!$result) {
		session_removeSession();
		return false;
	}
	return true;
}
function session_removeSession() {
	$id = session_id();
	$_SESSION = array();
	if (isset($_COOKIE[SESSION_COOKIE_NAME])) {
		setcookie(SESSION_COOKIE_NAME, '', time()-1000, SESSION_COOKIE_PATH);
	}
	session_destroy();
	session_unregister($id);
}
