<?php
require_once(dirname(__FILE__) . '/../lib/DataBase.php');
class MenuDB extends DataBase {
	private static $configListForMenu = array(
		'mda'=>array('sql'=>'SELECT ID, NAME || \'向け\' AS NAME, TOTAL FROM V_SUM_MEDIA ORDER BY ID', 'limit'=>10)
		,'styp'=>array('sql'=>'SELECT * FROM V_SUM_SITE_TYPE ORDER BY ID', 'limit'=>10)
		,'ctg'=>array('sql'=>'SELECT * FROM V_SUM_CATE ORDER BY SORT_KEY', 'limit'=>50)
		,'mod'=>array('sql'=>'SELECT * FROM V_SUM_MOOD ORDER BY SORT_KEY', 'limit'=>10)
		,'scl'=>array('sql'=>'SELECT * FROM V_SUM_SCALE ORDER BY SORT_KEY', 'limit'=>10)
		,'ctn'=>array('sql'=>'SELECT * FROM V_SUM_CAUTION ORDER BY SORT_KEY', 'limit'=>50)
		,'rst'=>array('sql'=>'SELECT * FROM V_SUM_RESTRICTION ORDER BY SORT_KEY', 'limit'=>10)
		,'cntr'=>array('sql'=>'SELECT * FROM V_SUM_COUNTRY ORDER BY TOTAL DESC', 'limit'=>20)
		,'chr'=>array('sql'=>'SELECT * FROM V_SUM_CHARA ORDER BY TOTAL DESC', 'limit'=>80)
		,'cptp'=>array('sql'=>'SELECT * FROM V_SUM_CP_TYPE ORDER BY SORT_KEY', 'limit'=>10)
		,'cpmf'=>array('sql'=>'SELECT * FROM V_SUM_CP_MF ORDER BY TOTAL DESC', 'limit'=>50)
		,'cpmm'=>array('sql'=>'SELECT * FROM V_SUM_CP_MM ORDER BY TOTAL DESC', 'limit'=>50)
		,'cpff'=>array('sql'=>'SELECT * FROM V_SUM_CP_FF ORDER BY TOTAL DESC', 'limit'=>50)
		//攻めCPに属するキャラ一覧
		,'sm'=>array(
			'sql'=>'SELECT D.CHARA_ID1 AS ID, M.NAME AS NAME, COUNT(D.CHARA_ID1) AS TOTAL
				FROM D_CP D, M_CHARA M
				WHERE D.CHARA_ID1 = M.ID
				GROUP BY ID
				ORDER BY TOTAL DESC'
			, 'limit'=>50
		)
		//受けCPに属するキャラ一覧
		,'uk'=>array(
				'sql'=>'SELECT D.CHARA_ID2 AS ID, M.NAME AS NAME, COUNT(D.CHARA_ID2) AS TOTAL
					FROM D_CP D, M_CHARA M
					WHERE D.CHARA_ID2 = M.ID
					GROUP BY ID
					ORDER BY TOTAL DESC'
			, 'limit'=>50
		)
	);
	/***********************************************************
	 * メニュー用の項目を取得する
	 * ---------------------------------------------------------
	 * [引数] なし
	 * [戻り] メニュー用のデータリスト
	 ***********************************************************/
	public function getMenuList() {
		$dataList = array();
		$this->connect();
		foreach(self::$configListForMenu as $key=>$val) {
			$sql = $val['sql'] . ' LIMIT ' . $val['limit'];
			$dataList[$key] = array();
			try {
				$rowCount = 0;
				$rows = $this->conn->query($sql);
				if ($rows) {
					foreach($rows as $row) {
						$rowCount++;
						$tempArray = array();
						if (($key == 'cpmf')||($key == 'cpmm')||($key == 'cpff')) {
							$tempArray['key'] = 'cp';
						} else {
							$tempArray['key'] = $key;
						}
						if (isset($row['ID'])) $tempArray['ID'] = $row['ID'];
						$tempArray['NAME'] = $row['NAME'] . '(' . $row['TOTAL'] . ')';
						if (isset($row['DESC'])) $tempArray['DESC'] = $row['DESC'];
						$dataList[$key][] = $tempArray;
					}
					$rows->closeCursor();
				} else {
					if (DEBUG && ($rowCount == 0)) {
						echo '***** ', $key, ' *****<br>', "\n";
						echo $sql, '<br>';
						echo 'Count=', $rowCount, '<br>';
					}
				}
			} catch (PDOException $e) {
				if (DEBUG) echo '<p>[' . __METHOD__ . "] {$key} " . $e->getMessage() . "</p>\n";
				break;
			}
		}
		$this->disconnect();
		return $dataList;
	}
}
