<?php
require_once(dirname(__FILE__) . '/../lib/common.php');
require_once(dirname(__FILE__) . '/../lib/util.php');
require_once(dirname(__FILE__) . '/../lib/DataBase.php');
class SearchDB extends DataBase {
	private static $sqlListForSiteInfo = array(
		'ctg'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.LONG_NAME, M.SORT_KEY
				FROM D_CATE D, M_CATE M
				WHERE D.SITE_ID IN (%s) AND D.CATE_ID1 = M.ID1 AND D.CATE_ID2 = M.ID2
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'scl'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.SORT_KEY
				FROM D_SCALE D, M_SCALE M
				WHERE D.SITE_ID IN (%s) AND D.SCALE_ID = M.ID
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'mod'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.SORT_KEY
				FROM D_MOOD D, M_MOOD M
				WHERE D.SITE_ID IN (%s) AND D.MOOD_ID = M.ID
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'cntr'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.LONG_NAME, M.SORT_KEY
				FROM D_COUNTRY D, M_COUNTRY M
				WHERE D.SITE_ID IN (%s) AND D.COUNTRY_ID = M.ID
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'chr'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.LONG_NAME, M.SORT_KEY
				FROM D_CHARA D, M_CHARA M
				WHERE D.SITE_ID IN (%s) AND D.CHARA_ID = M.ID
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'cptp'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.SORT_KEY
				FROM D_CP_TYPE D, M_CP_TYPE M
				WHERE D.SEX1 = M.ID1 AND D.SEX2 = M.ID2
				ORDER BY D.SITE_ID, D.PRIORITY, M.SORT_KEY'
		,'cpmf'=>'SELECT D.SITE_ID, M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID IN (%s) AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX != M2.SEX
				ORDER BY D.SITE_ID, D.PRIORITY'
		,'cpmm'=>'SELECT D.SITE_ID, M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID IN (%s) AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX = 0 AND M2.SEX = 0
				ORDER BY D.SITE_ID, D.PRIORITY'
		,'cpff'=>'SELECT D.SITE_ID, M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID IN (%s) AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX = 1 AND M2.SEX = 1
				ORDER BY D.SITE_ID, D.PRIORITY'
		,'ctn'=>'SELECT D.SITE_ID, D.PRIORITY, M.NAME, M.LONG_NAME, M.KIND, M.SORT_KEY
				FROM D_CAUTION D, M_CAUTION M
				WHERE D.SITE_ID IN (%s) AND D.CAUTION_ID = M.ID
				ORDER BY D.SITE_ID, M.KIND DESC, D.PRIORITY, M.SORT_KEY'
	);
	private $base_sql = array(
		'count'=>array(
			'select'=>array()
			,'from'=>array()
			,'where'=>array()
		)
		,'data'=>array(
			'select'=>array()
			,'from'=>array()
			,'join'=>''
			,'where'=>array()
			,'order'=>array()
		)
		,'where'=>array()
		,'where_ok'=>array()
		,'where_ng'=>array()
	);
	private static $sqlForCondition = array(
		'mda'=>'S.MEDIA = %d'
		,'styp'=>'S.SITE_TYPE = %d'
		,'rst'=>'S.RESTRICTION = %d'
		,'ctg'=>'EXISTS (SELECT D.SITE_ID FROM D_CATE D WHERE S.ID = D.SITE_ID AND D.CATE_ID1 = %d AND D.CATE_ID2 = %d)'
		,'scl'=>'EXISTS (SELECT D.SITE_ID FROM D_SCALE D WHERE S.ID = D.SITE_ID AND D.SCALE_ID = %d)'
		,'mod'=>'EXISTS (SELECT D.SITE_ID FROM D_MOOD D WHERE S.ID = D.SITE_ID AND D.MOOD_ID = %d)'
		,'ctn'=>'EXISTS (SELECT D.SITE_ID FROM D_CAUTION D WHERE S.ID = D.SITE_ID AND D.CAUTION_ID = %d)'
		,'cntr'=>'EXISTS (SELECT D.SITE_ID FROM D_COUNTRY D WHERE S.ID = D.SITE_ID AND D.COUNTRY_ID = %d)'
		,'chr'=>'EXISTS (SELECT D.SITE_ID FROM D_CHARA D WHERE S.ID = D.SITE_ID AND D.CHARA_ID = %d)'
		,'cptp'=>'EXISTS (SELECT D.SITE_ID FROM D_CP_TYPE D WHERE S.ID = D.SITE_ID AND D.SEX1 = %d AND D.SEX2 = %d)'
		,'cp'=>'EXISTS (SELECT D.SITE_ID FROM D_CP D WHERE S.ID = D.SITE_ID AND D.CHARA_ID1 = %d AND D.CHARA_ID2 = %d)'
		,'sm'=>'EXISTS (SELECT D.SITE_ID FROM D_CP D WHERE S.ID = D.SITE_ID AND D.CHARA_ID1 = %d)'
		,'uk'=>'EXISTS (SELECT D.SITE_ID FROM D_CP D WHERE S.ID = D.SITE_ID AND D.CHARA_ID2 = %d)'
	);
	function search($condition, $markList, $denyList) {
		list($countsql, $datasql) = $this->buildQuery($condition, $markList, $denyList);
		$dataList = array('total'=>0,'site'=>null);
		$this->connect();
		$dataList['total'] = $this->fetchSingle($countsql, null);
		if (!$dataList['total']) {
			$this->disconnect();
			return null;
		}
		$dataList['site'] = $this->fetchAll($datasql, null);
		if ($dataList['total'] && $condition->base['sw_o']) { //概要表示指定有
			$siteIdList = array();
			foreach($dataList['site'] as $site) $siteIdList[] = $site['ID'];
			$targetId = join(',', $siteIdList);
			$dataList['ctg'] = $this->searchSubDataListEachSite($targetId, 'ctg', false);
			$dataList['scl'] = $this->searchSubDataListEachSite($targetId, 'scl', false);
			$dataList['mod'] = $this->searchSubDataListEachSite($targetId, 'mod', false);
			$dataList['cntr'] = $this->searchSubDataListEachSite($targetId, 'cntr', false);
			$dataList['chr'] = $this->searchSubDataListEachSite($targetId, 'chr', false, 8);
			$dataList['cptp'] = $this->searchSubDataListEachSite($targetId, 'cptp', false);
			$dataList['cpmf'] = $this->searchSubDataListEachSite($targetId, 'cpmf', false, 5);
			$dataList['cpmm'] = $this->searchSubDataListEachSite($targetId, 'cpmm', false, 5);
			$dataList['cpff'] = $this->searchSubDataListEachSite($targetId, 'cpff', false, 5);
			$dataList['ctn'] = $this->searchSubDataListEachSite($targetId, 'ctn', false);
		}
		$this->disconnect();
		return $dataList;
	}
	private function searchSubDataListEachSite($targetIdList, $key, $isLongName, $limit=0) {
		$list = array();
		$nameCol = ($isLongName ? 'LONG_NAME' : 'NAME');
		$sql = sprintf(self::$sqlListForSiteInfo[$key], $targetIdList);
		try {
			$sth = $this->conn->prepare($sql);
			$sth->execute();
			while($row = $sth->fetch()) {
				$site_id = $row['SITE_ID'];
				if (!isset($list[$site_id])) {
					$list[$site_id] = array();
				}
				$list[$site_id][] = $row[$nameCol];
			}
		} catch (PDOException $e) {
			if (DEBUG) {
				echo '<p>[' . __METHOD__ . '] ' . $e->getMessage() . "</p>\n";
			}
			break;
		}
		if ($limit) {
			foreach ($list as $site_id=>$data) {
				if (count($data) > $limit) $list[$site_id] = array_slice($data, 0, $limit);
			}
		}
		return $list;
	}
	function initializeBaseSql() {
		$this->base_sql['count']['select'][] = 'COUNT(1)';
		$this->base_sql['count']['from'][] = 'D_SITE S';
		$this->base_sql['count']['where'][] = SQL_LIVE_SITE;
		$this->base_sql['data']['select'][] = 'S.*';
		$this->base_sql['data']['select'][] = "STRFTIME('%Y-%m-%d %H:%M', S.REG_DATE, 'localtime') AS F_REG_DATE";
		$this->base_sql['data']['select'][] = "STRFTIME('%Y-%m-%d %H:%M', S.UPD_DATE, 'localtime') AS F_UPD_DATE";
		$this->base_sql['data']['select'][] = "STRFTIME('%Y-%m-%d %H:%M', S.DEL_DATE, 'localtime') AS F_DEL_DATE";
		$this->base_sql['data']['select'][] = 'MKBN.NAME AS MKBN';
		$this->base_sql['data']['select'][] = 'STYP.NAME AS STYP';
		$this->base_sql['data']['select'][] = 'MSTAT.NAME AS MSTAT';
		$this->base_sql['data']['select'][] = 'BSTAT.NAME AS BSTAT';
		$this->base_sql['data']['select'][] = 'R.NAME AS RSTRCT';
		$this->base_sql['data']['select'][] = "REPLACE(R.NAME, '?', S.LOWER_AGE) AS RSTRCT";
		$this->base_sql['data']['select'][] = '('.SQL_SAMPLE_SITE.') AS SAMPLE';
		$this->base_sql['data']['select'][] = '('.sprintf(SQL_NEW_SITE, NEW_DAYS).') AS NEW';
		$this->base_sql['data']['select'][] = '('.sprintf(SQL_UPD_SITE, UPD_DAYS).') AS UPD';
		$this->base_sql['data']['select'][] = "(S.SORTABLE_DATE < JULIANDAY('now','-1 years')) AS OLD";
		$this->base_sql['data']['select'][] = '('.SQL_MOVE_SITE.') AS MOVED';
		$this->base_sql['data']['from'][] = 'D_SITE S';
		$this->base_sql['data']['from'][] = 'M_MEDIA MKBN';
		$this->base_sql['data']['from'][] = 'M_SITE_TYPE STYP';
		$this->base_sql['data']['from'][] = 'M_MANAGE_STATUS MSTAT';
		$this->base_sql['data']['from'][] = 'M_BROWSE_STATUS BSTAT';
		$this->base_sql['data']['from'][] = 'M_RESTRICTION R';
		$this->base_sql['data']['where'][] = SQL_LIVE_SITE;
		$this->base_sql['data']['where'][] = 'AND S.MEDIA = MKBN.ID';
		$this->base_sql['data']['where'][] = 'AND S.SITE_TYPE = STYP.ID';
		$this->base_sql['data']['where'][] = 'AND S.MANAGE_STATUS = MSTAT.ID';
		$this->base_sql['data']['where'][] = 'AND S.BROWSE_STATUS = BSTAT.ID';
		$this->base_sql['data']['where'][] = 'AND S.RESTRICTION = R.ID';
	}
	function buildQuery($condition, $markList, $denyList) {
		$this->initializeBaseSql();
		//更新履歴表示指定有
		if ($condition->base['sw_h']) {
			$this->base_sql['data']['select'][] = 'HST.LATEST';
			$this->base_sql['data']['select'][] = 'HST.TEXT AS HIST';
			$this->base_sql['data']['join'] = "LEFT JOIN (SELECT SITE_ID, DATE(MAX(UPD_DATE),'localtime') AS LATEST, TEXT
				FROM D_HIST GROUP BY SITE_ID HAVING LATEST > DATE('now','localtime','-1 years')) HST
				ON S.ID = HST.SITE_ID";
		}
		//表示順
		if ($condition->base['o']=='e') {
			$this->base_sql['data']['order'][] = 'S.ID'.($condition->base['rv'] ? ' DESC' : '');
		} else if ($condition->base['o']=='n') {
			$this->base_sql['data']['order'][] = 'S.NAME'.($condition->base['rv'] ? ' DESC' : '');
		} else if ($condition->base['o']=='r') {
			$this->base_sql['data']['order'][] = 'RANDOM()';
		} else {
			$this->base_sql['data']['order'][] = 'S.SORTABLE_DATE'.($condition->base['rv'] ? '' : ' DESC');
		}
		//検索範囲
		if ($condition->base['r'] == 'u') { //新着・更新
			$this->base_sql['where'][] = 'AND ('.sprintf(SQL_NEW_SITE, NEW_DAYS).' OR '.sprintf(SQL_UPD_SITE, UPD_DAYS).')';
		} else if ($condition->base['r'] == 'd') { //指定日数以内更新
			$this->base_sql['where'][] = 'AND '.sprintf(SQL_UPD_SITE, $condition->base['r_dv']);
		}
		//新着
		if ($condition->base['a'] == 'nw') {
			$this->base_sql['where'][] = 'AND '.sprintf(SQL_NEW_SITE, NEW_DAYS);
		}
		//更新
		if ($condition->base['a'] == 'up') {
			$this->base_sql['where'][]= 'AND NOT '.sprintf(SQL_NEW_SITE, UPD_DAYS);
			$this->base_sql['where'][] = 'AND '.sprintf(SQL_UPD_SITE, UPD_DAYS);
		}
		//マークサイト
		if ($condition->base['a'] == 'mk') {
			$str = 'AND '.sprintf(SQL_MARK_SITE, implode(',', $markList));
			$this->base_sql['where'][]= $str;
		}
		//マークサイト
		if ($condition->base['a'] == 'ot') {
			$str = 'AND '.sprintf(SQL_MARK_SITE, implode(',', $denyList));
			$this->base_sql['where'][]= $str;
		}
		//エラーサイト
		if ($condition->base['a'] == 'er') {
			$this->base_sql['where'][]= 'AND '.SQL_ERR_SITE;
		}
		//新着・更新ではステルス除外
		if (($condition->base['a'] == 'nw') || ($condition->base['a'] == 'up')) {
			$this->base_sql['where'][]= 'AND NOT '.SQL_STEALTH_SITE;
		}
		//新着・更新・検索結果ではエラーサイト除外
		if (($condition->base['a'] == 'nw') || ($condition->base['a'] == 'up') || ($condition->base['a'] == 'sh')) {
			$this->base_sql['where'][] = 'AND NOT '.SQL_ERR_SITE;
		}
		//検索語
		if ($condition->base['shwd']) {
			$escapeText = $this->escapeSql($condition->base['shwd']);
			$str = '(S.NAME LIKE '.$escapeText.' OR S.HANDLE LIKE '.$escapeText.' OR S.DESC LIKE '.$escapeText.")";
			$this->base_sql['where_ok'][] = $str;
		}
		//その他の検索対象条件
		if ($condition->option['ok']) {
			foreach ($condition->option['ok'] as $key=>$items) {
				foreach ($items as $index=>$val) {
					$str = vsprintf(self::$sqlForCondition[$key], explode(',', $val));
					$this->base_sql['where_ok'][] = $str;
				}
			}
		}
		//除外語
		if ($condition->base['ngwd']) {
			$escapeText = $this->escapeSql($condition->base['ngwd']);
			$str = ' AND S.NAME NOT LIKE '.$escapeText.' AND S.HANDLE NOT LIKE '.$escapeText.' AND S.DESC NOT LIKE '.$escapeText;
			$this->base_sql['where_ng'][] = $str;
		}
		//その他の検索除外条件
		if ($condition->option['ng']) {
			foreach ($condition->option['ng'] as $key=>$items) {
				foreach ($items as $index=>$val) {
					$str = ' AND NOT '.vsprintf(self::$sqlForCondition[$key], explode(',', $val));
					$this->base_sql['where_ng'][] = $str;
				}
			}
		}
		$ope = $condition->base['and'] ? ' AND ' : ' OR ';
		$where_ok = $this->base_sql['where_ok'] ? ' AND ('.join(' '.$ope.' ',$this->base_sql['where_ok']).')' : '';
		$where_ng = $this->base_sql['where_ng'] ? join(' ',$this->base_sql['where_ng']) : '';
		$countsql = 'SELECT '.join(',',$this->base_sql['count']['select'])
			.' FROM '.join(',',$this->base_sql['count']['from'])
			.' WHERE '.join(' ',$this->base_sql['count']['where'])
			.' '.join(' ',$this->base_sql['where'])
			.$where_ok
			.$where_ng;
		$datasql = 'SELECT '.join(',',$this->base_sql['data']['select'])
			.' FROM '.join(',',$this->base_sql['data']['from'])
			.' '.$this->base_sql['data']['join']
			.' WHERE '.join(' ',$this->base_sql['data']['where'])
			.' '.join(' ',$this->base_sql['where'])
			.$where_ok
			.$where_ng
			.' ORDER BY '.join(' ',$this->base_sql['data']['order'])
			.' LIMIT '
			;
			
		$offset = $condition->base['p'] * $condition->base['c'];
		if ($condition->base['n_c']) { //検索結果画面での件数変更時
			$condition->base['p'] = intval($offset / $condition->base['n_c']);
			$offset = $condition->base['p'] * $condition->base['n_c'];
			$condition->base['c'] = $condition->base['n_c'];
			$datasql .= $condition->base['c'].' OFFSET '.$offset;
			$condition->base['n_c'] = '0'; //処理が終わったので初期化
		} else {
			$datasql .= $condition->base['c'].' OFFSET '.$offset;
		}
		return array($countsql, $datasql);
	}
	private function escapeSql($sql) {
		$escape = sqlescape($sql);
		$escapeText = "'%".$escape['str']."%'";
		if ($escape['escape']) $escapeText .= " ESCAPE '$'";
		return $escapeText;
	}
}
