<?php
require_once(dirname(__FILE__) . '/../lib/common.php');
require_once(dirname(__FILE__) . '/../lib/DataBase.php');
class SiteDetail extends DataBase {
	private static $sqlList = array(
		'cate'=>'SELECT M.LONG_NAME AS NAME, M.SORT_KEY
				FROM D_CATE D, M_CATE M
				WHERE D.SITE_ID = ? AND D.CATE_ID1 = M.ID1 AND D.CATE_ID2 = M.ID2
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'scale'=>'SELECT M.NAME AS NAME, M.SORT_KEY
				FROM D_SCALE D, M_SCALE M
				WHERE D.SITE_ID = ? AND D.SCALE_ID = M.ID
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'mood'=>'SELECT M.NAME AS NAME, M.SORT_KEY
				FROM D_MOOD D, M_MOOD M
				WHERE D.SITE_ID = ? AND D.MOOD_ID = M.ID
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'country'=>'SELECT M.LONG_NAME AS NAME, M.SORT_KEY
				FROM D_COUNTRY D, M_COUNTRY M
				WHERE D.SITE_ID = ? AND D.COUNTRY_ID = M.ID
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'chara'=>'SELECT D.PRIORITY, M.LONG_NAME AS NAME, M.SORT_KEY
				FROM D_CHARA D, M_CHARA M
				WHERE D.SITE_ID = ? AND D.CHARA_ID = M.ID
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'cptype'=>'SELECT M.NAME AS NAME, M.SORT_KEY
				FROM D_CP_TYPE D, M_CP_TYPE M
				WHERE D.SITE_ID = ? AND D.SEX1 = M.ID1 AND D.SEX2 = M.ID2
				ORDER BY D.PRIORITY, M.SORT_KEY'
		,'cpmf'=>'SELECT M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID = ? AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX != M2.SEX
				ORDER BY D.PRIORITY'
		,'cpmm'=>'SELECT M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID = ? AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX = 0 AND M2.SEX = 0
				ORDER BY D.PRIORITY'
		,'cpff'=>'SELECT D.SITE_ID, M1.NAME || \'×\' || M2.NAME AS NAME, D.PRIORITY
				FROM D_CP D, M_CHARA M1, M_CHARA M2
				WHERE D.SITE_ID = ? AND D.CHARA_ID1 = M1.ID AND D.CHARA_ID2 = M2.ID AND M1.SEX = 1 AND M2.SEX = 1
				ORDER BY D.PRIORITY'
		,'caution'=>'SELECT M.LONG_NAME AS NAME, M.KIND, M.SORT_KEY
				FROM D_CAUTION D, M_CAUTION M
				WHERE D.SITE_ID = ? AND D.CAUTION_ID = M.ID
				ORDER BY M.KIND DESC, D.PRIORITY, M.SORT_KEY'
		,'hist'=>"SELECT DATE(UPD_DATE, 'localtime') AS F_UPD_DATE, TEXT
				FROM D_HIST
				WHERE SITE_ID = ? AND (F_UPD_DATE > DATE('now', 'localtime', '-1 years'))
				ORDER BY UPD_DATE DESC
				LIMIT 6"
	);
	public function selectSiteDetail($site_id) {
		$dataList = array();
		$sql = 'SELECT S.*'
			.", STRFTIME('%Y-%m-%d %H:%M', S.REG_DATE, 'localtime') AS F_REG_DATE"
			.", STRFTIME('%Y-%m-%d %H:%M', S.UPD_DATE, 'localtime') AS F_UPD_DATE"
			.", STRFTIME('%Y-%m-%d %H:%M', S.DEL_DATE, 'localtime') AS F_DEL_DATE"
			.', MKBN.NAME AS MKBN, STYP.NAME AS STYP, MSTAT.LONG_NAME AS MSTAT, BSTAT.LONG_NAME AS BSTAT'
			.", REPLACE(R.LONG_NAME, '?', S.LOWER_AGE) AS RSTRCT"
			.',('.SQL_SAMPLE_SITE.') AS SAMPLE'
			.',('.sprintf(SQL_NEW_SITE, NEW_DAYS).') AS NEW'
			.',('.sprintf(SQL_UPD_SITE, UPD_DAYS).') AS UPD'
			.',('.SQL_OLD_SITE.') AS OLD'
			.',('.SQL_MOVE_SITE.') AS MOVED'
		.' FROM D_SITE S, M_MEDIA MKBN, M_SITE_TYPE STYP, M_MANAGE_STATUS MSTAT, M_BROWSE_STATUS BSTAT
			, M_RESTRICTION R
		WHERE S.ID = ?'
			.' AND '.SQL_LIVE_SITE
			.' AND S.MEDIA = MKBN.ID
			AND S.SITE_TYPE = STYP.ID
			AND S.MANAGE_STATUS = MSTAT.ID
			AND S.BROWSE_STATUS = BSTAT.ID
			AND S.RESTRICTION = R.ID';
		$this->connect();
		try {
			$sth = $this->conn->prepare($sql);
			$sth->execute(array($site_id));
			$row = $sth->fetch();
			if ($row) {
				$dataList['site'] = $row;
			}
		} catch (PDOException $e) {
			if (DEBUG) {
				echo '<p>[' . __METHOD__ . '] ' . $e->getMessage() . "</p>\n";
			}
			return;
		}
		$dataList['cate'] = $this->selectSubItems($site_id, 'cate');
		$dataList['scale'] = $this->selectSubItems($site_id, 'scale');
		$dataList['mood'] = $this->selectSubItems($site_id, 'mood');
		$dataList['country'] = $this->selectSubItems($site_id, 'country');
		$dataList['chara'] = $this->selectSubItems($site_id, 'chara');
		$dataList['cptype'] = $this->selectSubItems($site_id, 'cptype');
		$dataList['cpmf'] = $this->selectSubItems($site_id, 'cpmf');
		$dataList['cpmm'] = $this->selectSubItems($site_id, 'cpmm');
		$dataList['cpff'] = $this->selectSubItems($site_id, 'cpff');
		$dataList['caution'] = $this->selectSubItems($site_id, 'caution');
		$dataList['hist'] = $this->selectHistory($site_id);
		$this->disconnect();
		return $dataList;
	}
	private function selectHistory($site_id) {
		$this->connect();
		$list = $this->fetchAll(self::$sqlList['hist'], array($site_id));
		$this->disconnect();
		return $list;
	}
	private function selectSubItems($site_id, $key) {
		$this->connect();
		$list = $this->fetchSingleList(self::$sqlList[$key], array($site_id), 'NAME');
		$this->disconnect();
		return $list;
	}
}
