<?php
//Smarty
require_once(dirname(__FILE__).'/../../../../../search/pg/config_smarty.php');

//ロジック
require_once(dirname(__FILE__).'/../../../../../search/pg/lib/common.php');
require_once(LIB_PATH.'/util.php');
require_once(LIB_PATH.'/EazyLog.php');
require_once(LIB_PATH.'/session.php');
require_once(LIB_PATH.'/DataBase.php');
define('SQL_FILE_DIR', SQLITE_DATA_DIR.'sql');
define('MSG_INVALID_REQUEST', '不正なリクエストです。');
define('LOCK_TERM_MAX', 48); //単位は時間
define('LOCK_TERM_MIN', 30); //単位は分
$tableNames = array(
	'B_BASE'
	,'M_BROWSE_STATUS'
	,'M_CATE'
	,'M_CAUTION'
	,'M_CHARA'
	,'M_COUNTRY'
	,'M_CP_TYPE'
	,'M_MANAGE_STATUS'
	,'M_MEDIA'
	,'M_MOOD'
	,'M_RESTRICTION'
	,'M_SCALE'
	,'M_SITE_TYPE'
	,'D_CATE'
	,'D_CAUTION'
	,'D_CHARA'
	,'D_COUNTRY'
	,'D_CP'
	,'D_CP_TYPE'
	,'D_HIST'
	,'D_MOOD'
	,'D_SCALE'
	,'D_SITE'
	,'D_USER'
	,'V_SUM_CATE'
	,'V_SUM_CAUTION'
	,'V_SUM_CHARA'
	,'V_SUM_COUNTRY'
	,'V_SUM_CP_FF'
	,'V_SUM_CP_MF'
	,'V_SUM_CP_MM'
	,'V_SUM_CP_TYPE'
	,'V_SUM_MEDIA'
	,'V_SUM_MOOD'
	,'V_SUM_SCALE'
	,'V_SUM_SITE_TYPE'
	,'V_SUM_RESTRICTION'
);
$itemDefines = array(
		'mail'=>array('label'=>'メールアドレス', 'pattern'=>'/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/', 'maxlength'=>30, 'need'=>true)
		,'pwd'=>array('label'=>'ログインパスワード', 'pattern'=>'/^[0-9a-zA-Z\-_]+$/', 'maxlength'=>30, 'need'=>true)
		,'handle'=>array('label'=>'ハンドル', 'pattern'=>'/.*/', 'maxlength'=>10, 'need'=>true)
		,'handle_kana'=>array('label'=>'ハンドルふりがな', 'pattern'=>'/^[ぁ-んァ-ヶー・]+$/u', 'maxlength'=>20, 'need'=>false)
		,'limit_count'=>array('label'=>'連続ログイン失敗回数上限', 'pattern'=>'/^[0-9]$/', 'maxlength'=>1, 'need'=>true)
		,'lock_hh'=>array('label'=>'連続ログイン失敗時ロック時間(時間)', 'pattern'=>'/^\d{1,2}$/', 'maxlength'=>2, 'need'=>false)
		,'lock_mn'=>array('label'=>'連続ログイン失敗時ロック時間(分)', 'pattern'=>'/^\d{1,2}$/', 'maxlength'=>2, 'need'=>false)
		,'use_mail'=>array('label'=>'メール連絡', 'pattern'=>'/^[01]$/', 'maxlength'=>1, 'need'=>true)
	);
$log = new EazyLog();
checkSession($log);
$db = new DataBase();
$cnn = $db->connect();
$tableList = getTableList($db);
$diff = array_diff($tableNames, $tableList);
$msgs = array();
if (!count($diff)) { //必要テーブルが全部ある
} else if (count($diff) == count($tableNames)) { //必要テーブルが全くない初期状態
	if (($_SERVER['REQUEST_METHOD'] === 'GET') && (!$_GET)) {
		$msgs[] = initializeDb($db, $log, $tableNames, $tableList);
		$tableList = getTableList($db);
		$diff = array_diff($tableNames, $tableList);
	} else { //GET以外のメソッド、またはGETだがパラメータあり
		dieWithLog(MSG_INVALID_REQUEST.' METHOD='.$_SERVER['REQUEST_METHOD'].($_GET ? ' keys='.join(','.array_keys($_GET)).' values='.join(','.array_values($_GET)) : ''));
	}
} else { //必要テーブルが一部ない
	$db->disconnect();
	dieWithLog($log, 'データが不整合です。データファイルをリネームまたは削除してから、このページに再アクセスすることで初期化してください。');
}
$baseInfoList = $db->fetchAll('SELECT * FROM B_BASE LIMIT 1', null);
if (!$baseInfoList) dieWithLog($log, '基本情報が登録されていません。');
$baseInfo = $baseInfoList[0];
if (strlen($baseInfo['ADMIN_PWD'])) dieWithLog($log, '既に初期設定されています。');
$errMsgs = null;
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
	$errMsgs = checkPostParam($log, $baseInfo, $itemDefines);
	if (!$errMsgs) {
		//DBを更新
		$sql = 'UPDATE B_BASE SET ADMIN_MAIL = '.$cnn->quote($_POST['mail'])
				.', ADMIN_HANDLE = '.$cnn->quote($_POST['handle'])
				.', ADMIN_HANDLE_KANA = '.$cnn->quote($_POST['handle_kana'])
				.', ADMIN_PWD = '.$cnn->quote(md5($_POST['pwd']))
				.', FAIL_LOGIN_LIMIT = '.$_POST['limit_count']
				.', LOCK_TERM = '.($_POST['lock_hh']*60+$_POST['lock_mn'])
				.', USE_MAIL = '.$_POST['use_mail']
		;
		$result = $db->beginTransaction();
		if (!$result) dieWithLog($log, 'トランザクションを開始できません。');
		$count = $db->execSql($sql);
		if (!$count) {
			$db->rollback();
			dieWithLog($log, $sql.'<br>管理者情報を設定できません。');
		}
		$result = $db->commit();
		if (!$result) dieWithLog($log, '管理者情報を登録できません。');
		$db->disconnect();

		//セッション開始
		session_initializeDefine();
		session_start();
		$_SESSION['handle'] = $_POST['handle'];
		session_write_close();
		header('Location: main.php');
		exit;
	}
} else if ($_SERVER['REQUEST_METHOD'] === 'GET') {
	$db->disconnect();
	$_POST['mail'] = '';
	$_POST['pwd'] = '';
	$_POST['handle'] = $baseInfo['ADMIN_HANDLE'];
	$_POST['handle_kana'] = $baseInfo['ADMIN_HANDLE_KANA'];
	$_POST['limit_count'] = $baseInfo['FAIL_LOGIN_LIMIT'];
	$_POST['lock_hh'] = intval($baseInfo['LOCK_TERM'] / 60);
	$_POST['lock_mn'] = $baseInfo['LOCK_TERM'] % 60;
	$_POST['use_mail'] = $baseInfo['USE_MAIL'];
} else {
	dieWithLog(MSG_INVALID_REQUEST.' METHOD='.$_SERVER['REQUEST_METHOD']);
}
header('pragma: no-cache');
header('cache-control: no-cache');
header('expires: -1');

//値の設定と出力
$smarty->assign('msgs', $msgs);
$smarty->assign('errMsgs', $errMsgs);
$smarty->assign('mail', $_POST['mail']);
$smarty->assign('pwd', $_POST['pwd']);
$smarty->assign('handle', $_POST['handle']);
$smarty->assign('handle_kana', $_POST['handle_kana']);
$smarty->assign('limit_count', $_POST['limit_count']);
$smarty->assign('lock_hh', $_POST['lock_hh']);
$smarty->assign('lock_mn', $_POST['lock_mn']);
$smarty->assign('lock_term_max', $_POST['LOCK_TERM_MAX']);
$smarty->assign('use_mail', $_POST['use_mail']);
$smarty->display('admin/start.tpl');

//テーブルおよびビューの一覧を取得
function getTableList($db) {
	return array_values($db->fetchSingleList("SELECT name FROM SQLITE_MASTER WHERE TYPE IN ('table', 'view')", null, 'name'));
}
//セッションの有無をチェック
function checkSession($log) {
	session_setPath();
	session_setCookieParams();
	$id = session_id();
	if (strlen($id)) dieWithLog($log, 'ログイン中です。まずログアウトしてください。');
	return true;
}
//POSTパラメータをチェック
function checkPostParam($log, $baseInfo, $defines, $encoding='UTF-8') {
	$msgList = array();
	mb_regex_encoding($encoding);
	foreach($defines as $key=>$define) {
		$_POST[$key] = getPostParam($log, $key, $define['maxlength']);
		$errmsg = checkPattern($_POST[$key], $define);
		if ($errmsg) $msgList[] = $errmsg;
	}

	//ロック時間のチェック
	$hh = $_POST['lock_hh'];
	if (!count($hh)) $hh = 0;
	$mn = $_POST['lock_mn'];
	if (!count($mn)) $mn = 0;
	$mn += $hh * 60;
	if ($mn < LOCK_TERM_MIN) $msgList[] = 'ロック時間は'.LOCK_TERM_MIN.'分以上にしてください。';
	if ($mn > (LOCK_TERM_MAX*60)) $msgList[] = 'ロック時間は'.LOCK_TERM_MAX.'時間以内にしてください。';

	return $msgList;
}
//入力項目のチェック
function checkPattern($val, $define, $encoding='UTF-8') {
	$pattern = $define['pattern'];
	$label = $define['label'];
	$need = $define['need'];
	if (!mb_strlen($val, $encoding)) {
		if ($need) return $label.'が入力されていません。';
		return null;
	}
	if (!preg_match($pattern, $val)) return $label.'の形式または値が不正です。';
	return null;
}
function getPostParam($log, $name, $maxlen, $need=true, $encoding='UTF-8') {
	if ($need && !isset($_POST[$name])) dieWithLog($log, MSG_INVALID_REQUEST.' no parameter - '.$name);
	$val = removeControlCode($_POST[$name]);
	if (mb_strlen($val, $encoding) > $maxlen) dieWithLog($log, MSG_INVALID_REQUEST.' '.$name.'='.$val);
	return $val;
}
function initializeDb($db, $log, $tableNames, $tableList) {
	if (!chdir(SQL_FILE_DIR)) dieWithLog($log, 'ディレクトリを変更できません。');
	$sqlFileNames = array('create_master.sql','create_data.sql','create_view.sql','insert_master.sql');
	$cnn = $db->connect();
	$db->beginTransaction();
	try {
		foreach($sqlFileNames as $name) {
			$log->writeDebug($name);
			if (!file_exists($name)) rollbackAndDie($db, $log, 'ファイルがありません - '.$name);
			$cnn->exec(file_get_contents($name));
			$log->writeDebug($db->errorInfo());
			if ($db->isError()) {
				rollbackAndDie($db, $log, '['.$name.'] '.implode(' ', $db->errorInfo()));
			}
		}
	} catch(PDOException $e) {
		rollbackAndDie($db, $log, implode(' ', $db->errorInfo()));
	}
	$db->commit();
	if ($db->isError()) abort('データファイルの初期化で、トランザクションの確定に失敗しました');
	return 'データファイルを初期化しました。';
}
function rollbackAndDie($db, $log, $msg) {
	$result = $db->rollBack();
	if ($result === false) dieWithLog($log, $msg.'トランザクションの破棄に失敗しました。');
	dieWithLog($log, $msg);
}
function dieWithLog($log, $msg) {
	$log->writeError($msg);
	abort($msg);
}
